<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-06-20 15:34:42
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="1" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <nonconformityReviewSheet-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </nonconformityReviewSheet-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <!-- <failureType-search ref="searchOrUpdate" @refreshDataList="conditionSearchSubmit"></failureType-search> -->
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{ $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import nonconformityReviewSheetAdd from "./components/nonconformityReviewSheet-add"
import nonconform from '@/filters/nonconform'
// import AddOrUpdate from './params-add-or-update'
// import failureTypeSearch from "./components/failureTypeSearch"
// import available from "./components/available.vue"
import basicSearch from "@/mixins/basic-search"
import i18n from "@/i18n"
const tableProps = [
  {
    prop: 'title',
    label: i18n.t("disqualification.title"),
    align: 'center'
  },
  {
    prop: 'productCode',
    label: i18n.t("disqualification.productCode"),
    align: 'center'
  },
  {
    prop: 'productName',
    label: i18n.t("disqualification.productName"),
    align: 'center'
  },
  {
    prop: 'orderNumber',
    label: i18n.t("disqualification.orderNumber"),
    align: 'center'
  },
  {
    prop: 'batchNo',
    label: i18n.t("disqualification.batchNo"),
    align: 'center'
  },
  {
    prop: 'inspectionTypeId',
    label: i18n.t("disqualification.inspectionTypeId"),
    align: 'center',
    filter: nonconform('inspectionType'),
  },
  {
    prop: 'supplierName',
    label: i18n.t("disqualification.supplierName"),
    align: 'center'
  },
  {
    prop: 'reportTime',
    label: i18n.t("disqualification.reportTime"),
    align: 'center'
  },
  {
    prop: 'userName',
    label: i18n.t("disqualification.userName"),
    align: 'center'
  },
  {
    prop: 'disposalStatus',
    label: i18n.t("disqualification.disposalStatus"),
    align: 'center'
  },
  {
    prop: 'productTypeName',
    label: i18n.t("disqualification.productTypeName"),
    align: 'center'
  },
  {
    prop: 'disposalMethod',
    label: i18n.t("disqualification.disposalMethod"),
    align: 'center'
  },
  {
    prop: 'disposalTime',
    label: i18n.t("disqualification.disposalTime"),
    align: 'center'
  },
  {
    prop: 'remark',
    label: i18n.t("disqualification.remark"),
    align: 'center'
  }
]
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
];
export default {
  mixins: [basicPage, basicSearch],
  components: {
    // failureTypeSearch,
    nonconformityReviewSheetAdd
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/nonconform/qmsNonconformityReviewSheet/approvePage",
        deleteURL: "/nonconform/qmsNonconformityReviewSheet",
        exportUrl: '/nonconform/qmsNonconformityReviewSheet/export'
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: '',
      searchOrUpdateVisible: false,
      formConfig: [
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: i18n.t('add'),
          name: "add",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t('export'),
          name: "export",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t('search'),
          name: "search",
          color: "primary",
        }
      ],
    };
  },
  // components: {
  //   AddOrUpdate,
  // },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    conditionSearchSubmit(dataForm) {
      this.listQuery.code = dataForm.code
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.failureTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrEditTitle = this.$t('edit')
        this.addOrUpdateVisible = true;
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1
          this.getDataList();
          break;
        case "export":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1
          this.exportHandl();
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
      }
    },
  }
};
</script>
